﻿using System;

class Program
{
    public int value = 0xff;

    static unsafe void Main(string[] args)
    {
        string a = "test is good";
        string b = a;

        IntPtr ptrA = GetRefAddress(a);
        IntPtr ptrB = GetRefAddress(b);

        Console.WriteLine($"ptrA: 0x{ptrA.ToInt64().ToString("x")}");
        Console.WriteLine($"ptrB: 0x{ptrB.ToInt64().ToString("x")}");
    }

    private unsafe static IntPtr GetRefAddress(object pg)
    {
        TypedReference refA = __makeref(pg);
        return **(IntPtr**)&refA;
    }
}
